% 4CM - Latent Model with Logistic growth
clc;clear;

% Parameter Initialization
s = 10;r = 0.03;Tmax = 1500;mu = 0.02;alpha = 2.4;beta = 0.24;
k1 = 2.4e-5;k2 = 3e-3;N = 1400;

%Non-infective equilibrium T-cell count with r
p = r - mu;
T0r = (Tmax/(2*r))* (p + sqrt(p^2 + 4*s*(r/Tmax)));

%Non-infective equilibrium T-cell count with r_n
r_n = 1.1*0.03;
p = r_n - mu;
T0r_n = (Tmax/(2*r_n))* (p + sqrt(p^2 + 4*s*(r_n/Tmax)));

format short g
percent_inc = 100*(T0r_n - T0r)/T0r;
fprintf('The T-cell steady state increases by %3.2f%% \n', percent_inc);


%% Problem 2 calculuation
1 - ((k2+mu)*(alpha + k1*T0r)/(N*k1*k2*T0r))