clear; clc;

U = [1, 5, 10, 20, 40];

dx = 1e-1;
dt = 1e-3; %1e-2;

a = -2;
b = 200;

T = 4;

for vel = 1:5
    x = a:dx:b;
    n = T/dt;
    I = find(abs(x) < 1);
    c(1,:) = zeros(length(x), 1);
    c(1,I) = 5;
    
    for i = 1:n
        for j = 2:length(x)
            c(i+1, j) = c(i,j) - U(vel)*(dt/dx)*(c(i,j) - c(i, j-1));
        end
        
    end
    subplot(5,1, vel);
    plot(x, c(n+1, :)), title(['Problem 1, U = ', num2str(U(vel))]), 
    axis([-2,200,0,5]), xlabel('x'), ylabel('c(t,x)')
    
    %Maximum concentration at t=4
    M = max(c(end, :))
end
