clear; clc;

dx = 1e-1;
dt = 1e-3; %1e-2;

a = -2;
b = 15;

T = 10;

x = a:dx:b;
n = T/dt;
c(1,:) = zeros(1,length(x));
I = find(abs(x) < 1);
c(1,I) = 5;
       
figure;
U = zeros(1, length(x));

for j = 1:length(x)
    val = x(j);
    if  val > 0
        U(j) = val^2/(1 + val^2);
    end
end

pos=0;

for i = 1:n
    for j = 2:length(x)
        c(i+1, j) = c(i,j) - U(j)*(dt/dx)*(c(i,j) - c(i, j-1))...
            - (U(j)-U(j-1))*(dt/dx)*c(i,j);   
    end
        
    if sum(((i+1)*dt) == [1,2,4,10]) > 0
        pos = pos + 1;
        subplot(2,2,pos), plot(x, c(i+1, :)),
        title(['Problem 3, t=', num2str((i+1)*dt)]),
        axis([-2,15,0,6]),xlabel('x'), ylabel('c(t,x)')
    end
end

            
    


  

