clear; clc;

dx = 0.1;
dy = dx;
dt = 1e-2;

a = -20;
b = 20;

T = 3;

x = a:dx:b;
y = x;
n = T/dt;

figure;

c(1,:,:) = zeros(1, length(x), length(y));

%Initial Condition
for j = 1:length(x)
    for k = 1:length(y)
        R = sqrt((x(j)-5)^2 + (y(k)+10)^2);
        
        if (R < 4)
            c(1, j, k) = 50*(1+cos((pi*R)/4));
        end
    end
end

%z = squeeze(c(1,:,:));
%surf(x,y,z, 'EdgeColor', 'none');


for i = 1:n
    for j = 2:length(x)
        for k = 2:length(y)
            if x(j) == 0
                U = -sin(pi/2);
                V = cos(pi/2);
            else
                theta = atan(y(k)/x(j));
                U = -sin(theta);
                V = cos(theta);
            end
           
        c(i+1, j, k) = c(i,j,k) - U*(dt/dx)*(c(i,j,k) - c(i,j-1,k))...
            - V*(dt/dy)*(c(i,j,k) - c(i,j,k-1));   
        end
    end
end


z = squeeze(c(n+1,:,:));
surf(x,y,z', 'EdgeColor', 'none'), xlabel('x'), ylabel('y'), zlabel('c(4,x,y)')

maxval = max(max(z))

% plot(x, c(i, :)),
% title(['Problem 3, t=', num2str(i*dt)]),
%axis([-100,100,0,6]),xlabel('x'), ylabel('c(t,x)')
            
    


  

