clear; clc;

U = [1, 5, 10, 20, 40];

dx = 5e-1;
dt = 1e-2; %1e-2;

a = -2;
b = 200;

T = 4;

for vel = 1:5
    x = a:dx:b;
    t = 0:dt:T;
    n = T/dt;
    I = find(abs(x) < 1);
    c(1,:) = zeros(1,length(x));
    c(1,I) = 5;
    
    for i = 1:n
        for j = 2:length(x)-1
            c(i+1, j) = c(i,j) - U(vel)*(dt/dx)*(c(i,j) - c(i, j-1)) +...
                (dt/dx^2)*(c(i,j+1) - 2*c(i,j) + c(i, j-1));
        end
        
    end
    subplot(2,3, vel);
    surf(x, t, c, 'EdgeColor', 'none'), title(['Problem 5, U = ', num2str(U(vel))]), 
    axis([-3,200,0,4, 0, 6]), 
    xlabel('x'), ylabel('t'), zlabel('c(t,x)')
    
    set(gca, 'YDir', 'reverse');
    
    %Maximum concentration at t=4
    M = max(c(end, :))
end
