clear; clc;

dx = 1e-1; %1e-2; 5e-3
dt = 1e-2*dx^2;

a = -5;
b = 5;

T = 1;

x = a:dx:b;
t = 0:dt:T;
n = floor(T/dt);

%Constants
mu = 1;
D = 2e-1;
f = 0; %1e-1;
k = 1;
chi = 10;

c(1,:) = zeros(1,length(x));
p(1,:) = zeros(1,length(x));
J1 = find(abs(x) < dx);
c(1,J1) = 2;
J2 = find((abs(x+1) < dx) |  (abs(x+3) < dx) | (abs(x+4) < dx));
p(1,J2) = 1;

% subplot(1,2,1), plot(x, c(1, :)), title('SMA Concentration'),
% axis([a,b,-0.5,2.5]), xlabel('x'), ylabel('a(0,x)')
% 
% subplot(1,2,2), plot(x, p(1, :)), title('SMA Density'),
% axis([a,b,-0.5,2]), xlabel('x'), ylabel('p(0,x)')

count = 0;

for i = 1:n
        %c(i+1, 1) = c(i,1) - (dt/dx)*(c(i,1) - c(i, end-1));
%         c(i+1, 1) = 0;
%         c(i+1, end) = 0;
%         p(i+1, 1) = 0;
%         p(i+1, end) = 0;
        for j = 2:length(x)-1
            
            c(i+1,j) = c(i,j) +(dt/dx^2)*(mu*(c(i,j+1) -2*c(i,j) + c(i,j-1)) - chi*((c(i,j) - c(i, j-1))*(p(i,j) - p(i,j-1)) + c(i,j)*(p(i,j+1) -2*p(i,j) + p(i,j-1))));
            
            p(i+1,j) = p(i,j) + dt*(f*c(i+1,j) - k*p(i,j)) + D*(dt/dx^2)*(p(i,j+1) -2*p(i,j) + p(i,j-1));
            
            

        end
% if floor(i/10) == i/10
%     subplot(1,2,1), plot(x, c(i+1, :)), title('SMA Concentration'),
%     axis([a,b,-1,2]), xlabel('x'), ylabel('a(t,x)')
% 
%     subplot(1,2,2), plot(x, p(i+1, :)), title('SMA Density'),
%     axis([a,b,-1,1]), xlabel('x'), ylabel('p(t,x)')
% 
        
%     plot(x, c(i+1, :)), title('Problem 5, FTBS'),
%     axis([-1,1,-1,1]), xlabel('x'), ylabel('c(t,x)')

%     count = count + 1;
%     M(count) = getframe;
end
   
    
%plot(x, c(n+1, :)), title('SMA Concentration'),
%axis([a,b,-0.5,0.5]), xlabel('x'), ylabel('a(T,x)')

subplot(1,2,1), plot(x, c(n+1, :)), title('SMA Concentration'),
axis([a,b,-0.5,2]), xlabel('x'), ylabel('a(1,x)')
 
subplot(1,2,2), plot(x, p(n+1, :)), title('SMA Density'),
axis([a,b,-0.5,2]), xlabel('x'), ylabel('p(1,x)')
    
 
%movie(M)
%movie(M, 1, 24) %once normal speed - once slow motion
