clear; clc;

dx = 1e-2;
dt = 1e-1; %1e-2;
sigma = dt/(dx^2);

a = 0;
b = 10;

T = 4;
t = 0:dt:T;

x = a:dx:b;
m = length(x);
n = T/dt;

T(1,:) = zeros(m, 1);
u(1,:) = zeros(m, 1);

S(1,1:n) = ***;
S(2,1:n) = ***;

M = (1+2*sigma)*diag(ones(m-2,1))-sigma*diag(ones(m-3,1),1)...
        -sigma*diag(ones(m-3,1),-1);
[L,U] = lu(M);
    
for i = 1:n
    %Control and Dirichlet BCs
    T(i+1, 1) = S(i+1);
    u(i+1, end) = 0;
   
    %Implicit Solution
    b = T(i,2:m-1)' + dt*sin(pi*x(2:m-1))';
    y = L\b;
    T(i+1,2:m-1) = U\y;     
end

err = T - trueA;

plot(x, err(1:n, :)), title('Implicit Diffusion'), 
    xlabel('x'), ylabel('err(t,x)')

figure;
plot(x, T(1:n, :)), title('Implicit Diffusion'), 
   xlabel('x'), ylabel('A(t,x)')

