% Ostwald Ripening

clc;clear;
format long g;

% Parameter Initialization

G = 4e-3;
mu = [1e-3, 1e-4];
cs = 7.52e-7;
c0 = 1.05*cs;
k = 5e2/mu(1);

% Initial condition
x0 = [0.04; 0.08];

% constants of concentration
c1 = c0 + mu*x0.^3;

% Right side of ODE
f = @(t,x)  [k*(c1 - mu*x.^3 - cs*exp(G/x(1)));
    k*(c1 - mu*x.^3 - cs*exp(G/x(2)))];


% Time span
tSpan = [0 5];

        
% Differential Equation
[tOut xOut] = ode45(f, tSpan, x0); %ode15s

plot(tOut, xOut)

