% Ostwald Ripening Multisize

clc;clear;
format long g;


% Parameter Initialization

G = 4e-3;
mu = [1e-1, 1e-3];
cs = 7.52e-7;
c0 = 1.05*cs;
k = 5e7;


% Initial condition
x0 = [1e-2; 5e-2];

% constants of concentration
c1 = c0 + mu*x0.^3;


%Right side of ODE
f1 = @(t,x)  [k*(c1 - mu*x.^3 - cs*exp(G/x(1)));
    k*(c1 - mu*x.^3 - cs*exp(G/x(2)))];



%f = @(t,x)  [k*(c1 - mu*x.^3 - cs*exp(G/x(1)));
%    RHS_ripening(t,x)];

%f = @(t,x) RHS_ripening(t,x);



% Time span
tSpan = 0:1e-6:5e-4;

%tSpan = [0 5e-4];
        


% Differential Equation
%[tOut, xOut] = ode4(f1, tSpan, x0); %ode45, ode15s

%plot(tOut, xOut)


 xOut = ode4_multi(f1, tSpan, x0); %ode45, ode15s 
 plot(tSpan, xOut)



