function out = RHS_ripening(t,y)


% Parameter Initialization

G = 4e-9;
mus = [1e19, 1e16];
cs = 4e-6;
c0 = 1.05*cs;
k = 5e-2;
rho = 6473;

% Initial condition
x0 = [1e-7; 1e-8];


% mu & c1
mu = rho*k*mus;
c1 = c0 + mu*x0.^3;

% if c1 > mu*y.^3 - cs*exp(G./y(1))    
%     out(1) = k*(c1 - mu*y.^3 - cs*exp(G/y(2)))^2;
% else
%     out(1) = -k*(cs*exp(G/y(2)) - (c1 - mu*y.^3));
% end

% if c1 > mu*y.^3 - cs*exp(G./y(2))    
%     out(2) = k*(c1 - mu*y.^3 - cs*exp(G/y(2)))^2;
% else
%     out(2) = -k*(cs*exp(G/y(2)) - (c1 - mu*y.^3));
% end



if c1 > mu*y.^3 - cs*exp(G./y(2))    
    out = k*(c1 - mu*y.^3 - cs*exp(G/y(2)))^2;
else
    out = -k*(cs*exp(G/y(2)) - (c1 - mu*y.^3));
end

