function out = f(t,x)


% Parameter Initialization

rho = 6473;
G = 4e-9;
mu = [1e19, 1e16];
cs = 4e-6;
c0 = 1.05*cs;
k = 5e-2;


% Initial condition
x0 = [1e-7; 5e-8];


c1 = c0 + mu*x0.^3;


eps = 1e-10;

if x(1) < eps
    out(1) = 0;
else
    out(1) = k*(c1 - mu*x.^3 - cs*exp(G/x(1)));
end
if x(2) < eps
    out(2) = 0;
else
    out(2) = k*(c1 - mu*x.^3 - cs*exp(G/x(2)));
end

out = out';