% HIV Mutation Model with immune response
clear;clc;

% Coefficients
a = 5;
b = 4;
c = 5;
g = 1;
h = 1;
k = 1;

Ndiv = c*g/(a*k - b*h)

n=6;

Init = [0.05; zeros(2*n,1)];

f= @(t,y) [y(1)*(a - b*y(2*n+1) - c*y(n+1));
    y(2)*(a - b*y(2*n+1) - c*y(n+2));
    y(3)*(a - b*y(2*n+1) - c*y(n+3));
    y(4)*(a - b*y(2*n+1) - c*y(n+4));
    y(5)*(a - b*y(2*n+1) - c*y(n+5));
    y(6)*(a - b*y(2*n+1) - c*y(n+6));
    g*y(1) - k*y(n+1)*sum(y(1:n));
    g*y(2) - k*y(n+2)*sum(y(1:n));
    g*y(3) - k*y(n+3)*sum(y(1:n));
    g*y(4) - k*y(n+4)*sum(y(1:n));
    g*y(5) - k*y(n+5)*sum(y(1:n));
    g*y(6) - k*y(n+6)*sum(y(1:n));
    (h-k*y(2*n+1))*sum(y(1:n))];

[tOut, yOut] = ode45(f, [0,0.5], Init);
    
plot(tOut, yOut(:, 1:n))
hold on

Init = yOut(end, :)
Init(2) = 0.01 

[tOut, yOut] = ode45(f, [0.5,1], Init);

plot(tOut, yOut(:, 1:n))
hold on

Init = yOut(end, :)
Init(3) = 0.01 

[tOut, yOut] = ode45(f, [1,1.5], Init);

plot(tOut, yOut(:, 1:n))
hold on

Init = yOut(end, :)
Init(4) = 0.01 

[tOut, yOut] = ode45(f, [1.5, 2], Init);

plot(tOut, yOut(:, 1:n))
hold on

Init = yOut(end, :)
Init(5) = 0.01 

[tOut, yOut] = ode45(f, [2, 2.5], Init);

plot(tOut, yOut(:, 1:n))
hold on

Init = yOut(end, :)
%Init(6) = 0.01 

[tOut, yOut] = ode45(f, [2.5, 30], Init);

plot(tOut, yOut(:, 1:n))
hold on
