clear; clc;

dx = 1/20; %1e-2; 5e-3; 1e-3 (perfect)
dt = 0.8*dx;

a = -1;
b = 1;

T = 1.2;

x = a:dx:b;
t = 0:dt:T;
n = length(t);

exact = zeros(n, length(x));

c(1,:) = sin(2*pi*x);
exact(1,:) = c(1,:);
err = zeros(n,1);


%plot(x, c(1, :)), title('Problem 5, FTBS'), 
 %   axis([-1,1,-1,1]), xlabel('x'), ylabel('c(t,x)')
    
    for i = 1:n-1
        c(i+1, 1) = c(i,1) - (dt/dx)*(c(i,1) - c(i, end-1));
        exact(i+1,1) = sin(2*pi*(x(1)-t(i+1)));
        
        for j = 2:length(x)
            c(i+1, j) = c(i,j) - (dt/dx)*(c(i,j) - c(i, j-1));
            exact(i+1,j) = sin(2*pi*(x(j)-t(i+1)));
        end
%     plot(x, c(i+1, :)), title('Problem 5, FTBS'), 
%     axis([-1,1,-1,1]), xlabel('x'), ylabel('c(t,x)')

    err(i+1) = max(c(i+1, :) - exact(i+1,:));
    %M(i) = getframe;
   
    end
    
plot(x, c(n, :)), title('Problem 5, FTBS'),
axis([-1,1,-1,1]), xlabel('x'), ylabel('c^n_j')
hold on    
plot(x, exact(n, :),'-r'), title('Problem 5, Exact'), 
axis([-1,1,-1,1]), xlabel('x'), ylabel('c(t,x)')
    
format long g
err
%err(end)/dx
    
%    movie(M,1) %once normal speed - once slow motion
