clear; clc;

dx = 5e-2; %1e-2
dy = dx;
dt = 1e-1*dx^2;

a = -2;
b = 2;

%Constants
alpha = 0.1;


T = alpha^2/4;
t = 0:dt:T;
n = floor(T/dt);


x = a:dx:b;
y = x;

u(:,:,:) = zeros(length(t)+1,length(x),length(y));

for j = 1:length(x)
    for k = 1:length(x)
        if ((abs(x(j)) <= dx & y(k) >= 0 & y(k) <= 1) | (abs(y(k)) <= dy & x(j) >= 0 & x(j) <= 0.5))
            u(1,j,k) = 1;            
        end
    end
end


z = squeeze(u(1,:,:));
surf(x, y, z','EdgeColor', 'none'), title('Initial Dose D(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('D(x,y)')

for i = 1:n
        for j = 2:length(x)-1
            for k = 2:length(y)-1
                u(i+1,j,k) = u(i,j,k)...
                    + (dt/dx^2)*(u(i,j+1,k) -2*u(i,j,k) + u(i,j-1,k))...
                    + (dt/dy^2)*(u(i,j,k+1) -2*u(i,j,k) + u(i,j,k-1));
            end
        end
end

z = squeeze(u(n+1,:,:));
figure;
surf(x, y, z','EdgeColor', 'none'), title('Scattered shape E(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('E(x,y)')
