clear;clc;

dx = 2e-2; %2e-2
dy = dx;
dt = 1e-1*dx^2 %7e-3;

a = -2;
b = 2;

x = a:dx:b;
length(x)

y = a:dy:b;

alpha = 0.25;
T = alpha^2/4;
n = floor(T/dt);

c(1,:,:) = zeros(length(x), length(y));

for j = 1:length(x)
    for k = 1:length(y)
        if ((abs(x(j)) <= dx) && y(k)>= -dy && y(k) <=1)...
                || ( (abs(y(k)) <= dy) && x(j)>= 0 && x(j) <=1/2) 
            c(1,j,k) = 1;
        end 
    end
end

z = squeeze(c(1,:,:));
surf(x,y,z');
shading interp
axis ([-2 2 -2 2 0 2])

for i = 1:n
    for j = 2:length(x) - 1
        for k = 2:length(y) - 1
            c(i+1,j,k) = c(i,j,k) + (dt/(dx)^2)*(c(i,j+1,k) - 2*c(i,j,k) + c(i,j-1,k))...
                + (dt/(dy)^2)*(c(i,j,k+1) - 2*c(i,j,k) + c(i,j,k-1));
        end
    end
end

figure;
z = squeeze(c(n+1,:,:));
surf(x,y,z');
shading interp
axis ([-2 2 -2 2 0 2])




