clear;clc;

%Constants
alpha = 0.1;
beta = 0.25;
eta = 0.5;

T1 = alpha^2/4;
T2 = beta^2/4;

a = -2;
b = 2;

dx = 0.05;
dy = dx;
dt = 0.1*dx^2;

n1 = floor(T1/dt);
n2 = floor(T2/dt);

x = a:dx:b;
y = x;


u(1,:,:) = zeros(length(x), length(y));

for j = 1:length(x)
    for k = 1:length(y)
        if ((abs(x(j)+1) <= dx & abs(y(k)) <= 1 | (abs(y(k)+1) <= dy & abs(x(j)) <= 1)))
            u(1,j,k) = 1;            
        end
    end
end

z = squeeze(u(1,:,:));
surf(x, y, z'), title('Dosed Shape D(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('D(x,y)')

%,'EdgeColor', 'none'

w(1,:,:) = u(1,:,:);


sig = dt/(dx^2);

for i = 1:n1
    for j = 2:length(x)-1
        for k = 2:length(y)-1
            u(i+1,j,k) = u(i,j,k)...
                    + sig*(u(i,j+1,k) -2*u(i,j,k) + u(i,j-1,k))...
                    + sig*(u(i,j,k+1) -2*u(i,j,k) + u(i,j,k-1));
        end
    end
end

for i = 1:n2
    for j = 2:length(x)-1
        for k = 2:length(y)-1
            w(i+1,j,k) = w(i,j,k)...
                    + sig*(w(i,j+1,k) -2*w(i,j,k) + w(i,j-1,k))...
                    + sig*(w(i,j,k+1) -2*w(i,j,k) + w(i,j,k-1));
        end
    end
end



figure;
z = squeeze((1/(1+eta))*(u(end,:,:) + eta*w(end,:,:)));
surf(x, y, z'), title('Scattered shape E(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('E(x,y)')
