clear;clc;

%Constants
alpha = 0.1;
beta = 0.25;
eta = 0.5;

a = -2;
b = 2;

dx = 0.05;
dy = dx;
dt = 0.1*dx^2;

x = a:dx:b;
y = x;

T = alpha^2/4;
n = floor(T/dt);

u(1,:,:) = zeros(length(x), length(y));

%J = find( (( abs(x) <= 1) & (abs(y+1) <= dy)) | ((abs(y) <= 1) & (abs(x+1) <= dx))) 

%u(1,J) = 1;

for j = 1:length(x)
    for k = 1:length(y)
        if ((abs(x(j)+1) <= dx & abs(y(k)) <= 1 | (abs(y(k)+1) <= dy & abs(x(j)) <= 1)))
            u(1,j,k) = 1;            
        end
    end
end

z = squeeze(u(1,:,:));
surf(x, y, z'), title('Dosed Shape D(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('D(x,y)')

%,'EdgeColor', 'none'

sig = dt/(dx^2);

for i = 1:n
    for j = 2:length(x)-1
        for k = 2:length(y)-1
            u(i+1,j,k) = u(i,j,k)...
                    + sig*(u(i,j+1,k) -2*u(i,j,k) + u(i,j-1,k))...
                    + sig*(u(i,j,k+1) -2*u(i,j,k) + u(i,j,k-1));
        end
    end
end

figure;
z = squeeze(u(end,:,:));
surf(x, y, z'), title('Scattered shape E(x,y)'),
axis([a,b,a,b,0,1.5]), xlabel('x'), ylabel('y'), zlabel('E(x,y)')
