clear; clc;

dx = 5e-3; %5e-2
dt = 1e-1*dx^2;

a = -1;
b = 1;
x = a:dx:b;

N = 15;

%Constants
alpha = 1;%0.1;
beta = 0.25;
eta = 0.25; %0.5;

t1 = alpha^2/4;
t2 = beta^2/4;

E_target = @(s) Shape(s);

%plot(x, E_target(x)), title('Desired shape - E(x)'),
%axis([a,b,0,2]), xlabel('x'), ylabel('E(x)')

e = zeros(1, N+1);
d = e;
D = (-1/(2*pi))*ones(1, length(x));
E = D;
Et = E;
Dt = D;
for n = 0:N
    %Eint = @(s) E_target(s).*cos((n-1)*s) 
    %e(n) = (2/pi)*integral(Eint, 0, pi)
    Eint = @(s) cos(n*s);
    e(n+1) = (2/pi)*integral(Eint, 0, 0.5);
    d(n+1) = (1+eta)/(exp(-n^2*t1) + eta*exp(-n^2*t2))*e(n+1);
    D = D + d(n+1)*cos(n*x);
    E = E + e(n+1)*cos(n*x);
    
    Dt = Dt + (1 - n/N)*d(n+1)*cos(n*x);
    Et = Et + (1 - n/N)*e(n+1)*cos(n*x);
end

plot(x, E_target(x), x, E,'--r', x, D, '-.k'), title('E(x), D(x), and Appx to E(x)'),
axis([a,b,-5.5,5.5]), 
xlabel('x'), ylabel('E(x)/D(x)'), legend('E', ['E_{',num2str(N),'}'], ['D_{',num2str(N),'}'])

figure;
plot(x, E_target(x), x, Et,'--r', x, Dt, '-.k'), title('E(x), Dt(x), and Et(x)'),
axis([a,b,-5.5,5.5]), 
xlabel('x'), ylabel('Et(x)/Dt(x)'), legend('E', ['Et_{',num2str(N),'}'], ['Dt_{',num2str(N),'}'])


