clear;clc;

N = 40;

alph = 1;
beta = 0.25;
eta = 0.25;
dx = 2*pi/1000;

x = -pi:dx:pi;

e = zeros(1,N);
d = zeros(1,N);

Exp = @(x) Exposure(x);

E = (1/pi)*integral(Exp, 0, pi)*ones(1,length(x));
D = E;

for n = 1:N
    f = @(y) Exp(y).*cos(n*y);
    e(n) = (2/pi)*integral(f, 0, pi);
    d(n) = e(n)*(1+ eta)/(exp(-n^2*alph^2/4) + eta*exp(-n^2*beta^2/4));
    
    D = D + d(n)*cos(n*x);
    E = E + e(n)*cos(n*x); 
end

figure;
plot(x, Exp(x)), title('Desired vs Appx - E(x)'),
axis([-pi,pi,-0.5,2]), xlabel('x'), ylabel('E(x)')
hold on
plot(x, E, '--r'), 
axis([-pi,pi,-0.5,2]), xlabel('x'), ylabel('E_N(x)')
hold on
plot(x, D, '-.k'), title('Approximation to D(x)'),
axis([-pi,pi,-0.5,2]), xlabel('x'), ylabel('D_N(x)')

