clear; clc;

dx = 1e-2; %5e-2
dt = 1e-1*dx^2;

a = -5;
b = 5;

N = 10;

%Constants
alpha = 1;%0.1;
beta = 0.25;
eta = 0.25; %0.5;


T1 = alpha^2/4;
T2 = beta^2/4;

x = a:dx:b;

E_target = @(s) Shape(s);


%plot(x, E_target(x)), title('Desired shape - E(x)'),
%axis([a,b,0,2]), xlabel('x'), ylabel('E(x)')

D = zeros(1,N);
E = D;
Ex = (1/pi)*integral(E_target, 0, pi)*ones(1,length(x));
Dx = Ex;

for n = 1:N
    f = @(s) E_target(s).*cos(n*s);
    E(n) = (2/pi)*integral(f, 0, pi);
    D(n) = ((1+eta)/(exp(-n^2*T1) + eta*exp(-n^2*T2)))*E(n);
    Dx = Dx + D(n)*cos(n*x);
    Ex = Ex + E(n)*cos(n*x);
end

figure;

plot(x, E_target(x), x, Ex,'--r', x, Dx, '-.k'), title('E(x), D(x), and Appx to E(x)'),
axis([-1,1,-5.5,5.5]), 
xlabel('x'), ylabel('E(x)/D(x)'), legend('E', ['E_{',num2str(N),'}'], ['D_{',num2str(N),'}'])

% figure;
% plot(x, Dx), title('Necessary dosing function - D(x)'),
% axis([-1,1,-0.5,2.5]), 
% xlabel('x'), ylabel('D(x)')
