clear; clc;

dx = 5e-1; %5e-2
dy = dx;
dt = 1e-1*dx^2;

a = -5;
b = 5;

N = 15;
M = N;

%Constants
%alpha = 1;%0.1;
%beta = 0.25;
eta = 0.25; %0.5;

T1 = 0.01; %alpha^2/4;
T2 = 1; %beta^2/4;

x = a:dx:b;
y = a:dy:b;

Etarget = @(u,v) sin(u)'*sin(v);%TwoD_ShapeL(u,v);

surf(x,y, transpose(Etarget(x,y)),'EdgeColor', 'none')

E = zeros(N,M);
%D = E;
Ex = (1/pi)^2*integral2(Etarget, 0, pi, 0, pi).*ones(length(x), length(y));
%Dx = Ex;

for n = 1:N
    for m = 1:M
        f = @(u,v) Etarget(u,v).*cos(n*u).*cos(m*v);
        E(n,m) = (2/pi)^2*integral2(f, 0, pi, 0, pi);
        %D(n,m) = ((1+eta)/(exp(-n^2*T1) + eta*exp(-n^2*T2)))*E(n);
        %Dx = Dx + D(n)*cos(n*x);
        Ex = Ex + E(n,m)*cos(m*y)'*cos(n*x);
    end
end

%figure;
%surf(x,y, transpose(Etarget(x,y))), title('E(x)'),
%axis([0,2,-0.2,1.2]), 
%xlabel('x'), ylabel('y'), zlabel('E(x,y)')

%z = squeeze(Ex(:,:));

figure;
surf(x, y, Ex','--r'), title('Appx to E(x,y)'),
axis([a,b,a,b,-0.2,1.2]), 
xlabel('x'), ylabel('y'), zlabel('Ex(x,y)')

% figure;
% plot(x, Dx), title('Necessary dosing function - D(x)'),
% axis([0,2,-1,2]), 
% xlabel('x'), ylabel('D(x)')
