clear; clc;

dx = 1e-3; %5e-2

a = -pi;
b = pi;

N = 15;

%Constants
eta = 1;%0.25; %0.5;
alpha = 0.25;%0.1;
beta = 0.25;

T1 = alpha^2/4;
T2 = beta^2/4;

x = a:dx:b;

E_target = @(s) Shape(s);
%E_target = @(s) Shape1(s);

D = zeros(1,N);
E = D;
Dx = (1/pi);
%Dx = (1/pi)*integral(E_target, 0, pi)*ones(1,length(x));
Ex = Dx;

FDx = Dx;
FEx = Ex;

for n = 1:N
    %f = @(s) E_target(s).*cos(n*s);
    E(n) = (2/pi)*integral(@(s) cos(n*s), 0, 1);
    D(n) = (1+eta)*E(n)/(exp(-n^2*T1) + eta*exp(-n^2*T2));
    Dx = Dx + D(n)*cos(n*x);
    Ex = Ex + E(n)*cos(n*x);
    
    %Add Cesaro Sum
    FDx = FDx + (1 - (n/N))*D(n)*cos(n*x);
    FEx = FEx + (1 - (n/N))*E(n)*cos(n*x);
    
end

figure;
plot(x, E_target(x), x, Dx, '--r', x, FDx,'-.k'), 
title('D(x) and Fejer-summed D(x)'),
%axis([0,2,-2,3]), 
axis([a,b,-0.5,2.5]), 
xlabel('x'), ylabel('D(x)/FD(x)'),
legend('E',['D_{',num2str(N),'}'], ['FD_{',num2str(N),'}'])

figure;
plot(x, E_target(x), x, Ex,'--r', x, FEx, '-.k'), 
title('E(x), Appx to E(x), and Fejer-summed E(x) and'),
%axis([0,2,-0.2,1.2]), 
axis([a,b,-0.5,2.5]), 
xlabel('x'), ylabel('E(x)/FE(x)'),
legend('E', ['E_{',num2str(N),'}'], ['FE_{',num2str(N),'}'])




