clear; clc;

dx = 1;%1e-1;
dt = 0.1; %1e-2; 0.1*dx^2
sigma = dt/(dx^2);

a = -2;
b = 2;

T = 5;

x = a:dx:b;
m = length(x);

n = T/dt;
I = find(abs(x) < 1);
c(1,:) = zeros(m, 1);
c(1,I) = 1;

plot(x, c(1, :)), title('Implicit Diffusion'), 
xlabel('x'), legend('c(1,x)')
%     hold  on

M = diag((1+2*sigma)*ones(1, m-2))...
    - diag(sigma*ones(1,m-3), -1)...
    - diag(sigma*ones(1,m-3), 1);

[L,U] = lu(M);

for k = 1:n
    y = L\c(k,:)'
    c(k+1, :) = U\y;
    
end





%plot(x, c(1:n, :)), title('Implicit Diffusion'), 
%    xlabel('x'), ylabel('c(t,x)')

