clear; clc;

dx = 1e-3;
dt = 1e-1; %1e-2; 0.1*dx^2
sigma = dt/(dx^2);

a = -2;
b = 2;

T = 5;

x = a:dx:b;
m = length(x);

n = T/dt;
I = find(abs(x) < 1);
c(1,:) = zeros(m, 1);
c(1,I) = 1;

% plot(x, c(1, :)), title('Implicit Diffusion'), 
%     xlabel('x'), legend('c(1,x)')
%     hold  on
    
M = (1+2*sigma)*diag(ones(m-2,1))-sigma*diag(ones(m-3,1),1)...
        -sigma*diag(ones(m-3,1),-1);
[L,U] = lu(M);
    
for i = 1:n
    %Assuming Dirichlet BCs so that c(i,1) = c(i, m) = 0
    y = L\c(i,2:m-1)';
    c(i+1,2:m-1) = U\y; 
end

plot(x, c(1:n, :)), title('Implicit Diffusion'), 
    xlabel('x'), ylabel('c(t,x)')

%     plot(x, c(n, :)), title('Implicit Diffusion'), 
%     xlabel('x'), ylabel(['u(', num2str(T),',x)'])

    
    


  

