function y = basis(m, x)
% This is the basis function on the 4 centered on x(3). We evaluate at m.
h = x(2)-x(1);
g1=@(k) k^3;
g2=@(k) 1+3*k+3*k^2-3*k^3;

if(m>=x(1) && m<=x(2))
    y = (h^(-3))*g1(m-x(1));
elseif(m>=x(2) && m<=x(3))
    y = g2((m-x(2))/h);
elseif(m>=x(3) && m<=x(4))
    y = g2((x(4)-m)/h);
elseif(m>=x(4) && m<=x(5))
    y = (h^(-3))*g1(x(5)-m);
else
    y =0;
end

end