function error = colKdV(x)

% KdV Collocation
% This will first be the time independedent linear system
h = x(2)-x(1);
f = @(k) 0;



% f = @(k) k^5+7*k^4-12*k^3+24*k^2+96*k-120;
% % Actual Solution
% g  = @(k) k^2*(k-2)^2*(k+6);
% First we construct the basis functions
B = createBasis(x);
dB = createDBasis(x);
d3B = createD3Basis(x);

% Next we construct the necessary matrices (N-1)X(N+2) nonzero component.
% Bottom three rows await BCs.
V = createV(x,B);
V1 = createV1(x,dB);
V3 = createV3(x,d3B);

% We now modify these matrices to create one matrix, (N+2)X(N+2), using
% BCs.
M = initalize(x,V,V1,V3,B,dB);

b = satisfyF(x,f);

alpha = M\b;

createPlot(x,alpha,B);

end
