% function colKdVdep(x)
clear all; clc;

h=.1;
x = 0:h:3;

eps = 1;
mu = 1;
% This code implements collocation for time dependent KdV. We use implicit
% euler to time step.
dt = .01;
T = 3;
tStep = T/dt+1;
% Inital condition in time: g.
%soliton Passing dt=.005,mu = 4.84*10^(-4),eps = 1,h=.01
c = .3;
c2 = .1;
a = .5*sqrt(eps*c/mu);
b = a*eps*c;
a2 = .5*sqrt(eps*c2/mu);

g = @(k) 3*c*(sech(a*k-6))^2;%+3*c2*(sech(a2*k-8))^2;
gT = @(k,t) 3*c*(sech(a*k-b*t-6))^2;
%g = @(k) exp(-(k^2));


% First we construct the basis functions
B = createBasis(x);
dB = createDBasis(x);
d3B = createD3Basis(x);

% Next we construct the necessary matrices (N-1)X(N+2) nonzero component.
% Bottom three rows await BCs.
V = createV(x,B);
V1 = eps*createV1(x,dB);
V3 = mu*createV3(x,d3B);
C1 = BC1(x,B);
C2 = BC2(x,B);
C3 = BC3(x,dB);

M = (V+C1+C2+C3);
% Find initial condition:
init = inital(x,M,g);

%a2Soln = eXcrankIntegrator(x,V,V1,V3,C1,C2,C3,init,dt,tStep);

%a1Soln = tIntegrator(x,B,V,V1,(V3+C1+C2+C3),init,dt,tStep);

%aSoln = crankIntegrator(x,V,V1,V3,C1,C2,C3,init,dt,tStep);










