function aSoln = crankIntegrator(x,V,V1,V3,C1,C2,C3,init,dt,tStep)

N= length(x);
aSoln = zeros(N+2,tStep);
aSoln(:,1) = init;

for i = 2:tStep
    xevals = solnEval(x,V,aSoln(:,i-1));
    
    V1adj = createV1adj(x,V1,xevals);
    
    b = xevals - (dt/2)*V1adj*aSoln(:,i-1)-(dt/2)*V3*aSoln(:,i-1);
    
    M=C1+C2+C3+V+(dt/2)*V1adj+(dt/2)*V3;
    
    aSoln(:,i) = M\b;
end

%ned
end