function aSoln = eXcrankIntegrator(x,V,V1,V3,C1,C2,C3,init,dt,tStep)
% Implements extrapolated Crank Nicholson for KdV
N= length(x);
aSoln = zeros(N+2,tStep);
aSoln(:,1) = init;

% First two Steps

% Step 1
    
xevals = solnEval(x,V,aSoln(:,1));

V1adj = createV1adj(x,V1,xevals);

b = xevals - (dt/2)*V1adj*aSoln(:,1)-(dt/2)*V3*aSoln(:,1);

M=C1+C2+C3+V+(dt/2)*V1adj+(dt/2)*V3;

temp = M\b;

% Step 2
hat = .5*(temp+aSoln(:,1));
    
xevals = solnEval(x,V,aSoln(:,1));

V1adj = createV1adj(x,V1,hat);

b = xevals - (dt/2)*V1adj*aSoln(:,1)-(dt/2)*V3*aSoln(:,1);

M=C1+C2+C3+V+(dt/2)*V1adj+(dt/2)*V3;

aSoln(:,2) = M\b;


for i = 3:tStep
    hat = 1.5*solnEval(x,V,aSoln(:,i-1))-.5*solnEval(x,V,aSoln(:,i-2));
    
    xevals = solnEval(x,V,aSoln(:,i-1));
    
    V1adj = createV1adj(x,V1,hat);
    
    b = xevals - (dt/2)*V1adj*aSoln(:,i-1)-(dt/2)*V3*aSoln(:,i-1);
    
    M=C1+C2+C3+V+(dt/2)*V1adj+(dt/2)*V3;
    
    aSoln(:,i) = M\b;
end


end